clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_04_01.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-17
% Last Update : 2005-01-17
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Calcolo la precisione macchina eps del software tramite algoritmo');

% eps da la distanza tra 1 ed il successivo numero pi grande

eps = 1.0;
while ((eps + 1) > 1)
    eps = 0.5 .* eps; % dimezzo eps ad ogni ciclo
end
eps = 2 * eps;

disp(sprintf('precisione eps del software : %.16g', eps));

% Calcolo i valori approssimati di t,L,U per il software
% eps = k * B^(1-t)  dove B  la base (10 nel software)
% t  il numero di cifre significative
% k assume valore 1 o 1/2 a seconda che ci si faccia rispettivamente un
% troncamento o un arrotondamento rispettivamente.

t = 1 - log10(2 .* eps);

disp(sprintf('numero di cifre significative t : %d', round(t)));

% U  il massimo esponente che pu assumere la base prima di un overflow

base = 10;
U = 0;
while (base < Inf)
	base = base .* 10; % faccio crescere rapidamente la base
	U = U + 1;
end

disp(sprintf('massimo valore della caratteristica U : %d', U));

% L  l'esponente pi piccolo per il quale la base  diversa da 0

base = 10;
L = 0;
while (base > 0)
	base = base ./ 10; % faccio decrescere rapidamente la base
	L = L - 1;
end

disp(sprintf('minimo valore della caratteristica L : %d', L));


% -------------------------------------------------------------------------
% NOTE DI TEORIA
% -------------------------------------------------------------------------
%
% 1. Rappresentazione di un numero reale mediante un numero macchina.
% Per rappresentare un numero reale positivo x, dato nella forma 
% x = sign(x)mB^p, in un sistema di numeri macchina F(B, t, L, U) si agisce
% secondo il caso:
%    1. Il numero x  tale che L ? p ? U e di = 0 per i > t; 
%       allora x  un numero macchina ed  rappresentato esattamente;
%    2. La caratteristica p non appartiene a [L, U]. 
%       Il numero non pu essere rappresentato esattamente e si possono 
%       presentare i due casi: 
%       2.1. p < L, si dice che si  verificato un underflow, e solitamente
%            si assume come valore approssimato il numero 0. 
%            In alcuni casi si tratta di unapprossimazione inaccettabile; 
%       2.2. p > U, si dice che si  verificato un overflow, solitamente 
%            non si effettua nessuna approssimazione di valore, ma si 
%            blocca il calcolo.
%    3. La caratteristica p appartiene ad [L, U], ma le cifre di per i > t,
%       non sono tutte nulle. In questo caso si pone il problema di 
%       scegliere un suo rappresentante in F. Tale operazione viene 
%       indicata comunemente come operazione di arrotondamento anche se in 
%       realt possono essere utilizzate tecniche diverse. Loperazione di 
%       arrotondamento pu essere fatta tramite troncamento o 
%       arrotondamento.


% === EOF =================================================================