clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_07_01.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-18
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Risoluzione Ax=b con Gauss Naive');

n = input('Inserisci la dimensione del sistema: ');

if isnumeric(n) & (n > 0)
    % calcolo una nuova matrice finch il det(A) = 0 e finch l'utente
    % vuole continuare 
    reply = 's'; % risposte utente
    while strcmpi(reply, 's')
        reply = 'n';
        disp('genero una matrice casuale');
        A = rand(n)
        if (cond(A) >= 1/eps) | (controllaMinori(A) == 0)
            % chiede all'utente se generare una nuova matrice
            disp('la matrice non soddisfa i requisiti');
            reply = input('genero una nuova matrice? S/N [N]: ','s');
        else
            disp('genero la soluzione esatta del problema');
            xx = rand(n,1)

            disp('calcolo il vettore dei termini noti');
            b = A * xx

            disp('triangolarizzo il sistema');
            A = gaussNaive([A,b])
            
            disp('calcolo la soluzione approssimata');
            x = triangSup([A,b])

            % Stampa l'errore di approssimazione con la norma euclidea
            disp(sprintf('L''errore commesso  (norma euclidea): %d', norm(xx-x)));
        end
   end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% -------------------------------------------------------------------------
% NOTE DI TEORIA
% -------------------------------------------------------------------------
%
% 1. L'algoritmo Gauss Naive si pu applicare ad un sistema Ax=b solo se
% det(A)!=0 e se tutti i minori principali sono diversi da zero (akk!=0).
%
% 2. La complessit computazionale del metodo Gauss 'naive'  polinomiale
% dello stesso ordine di n3.
%
% 3. Metodi diretti per la risoluzione di un sistema lineare
% I metodi diretti, in assenza di errori di arrotondamento, risolvono un 
% sistema lineare in un numero finito di operazioni. 
% Sfruttano sostanzialmente il metodo di eliminazione di Gauss ricavando da
% unequazione una particolare incognita e sostituendola nelle equazioni 
% rimanenti, in questo modo il sistema si riduce di unequazione e di 
% unincognita, ripetendo il procedimento si arriva ad ottenere una sola 
% equazione in una sola incognita, ricavando e sostituendo nelle diverse 
% equazioni si ottiene la soluzione.
%
% 4. Numero di condizionamento di una matrice
% Se ||.|| indica una norma naturale di matrice il Condizionamento  di una 
% matrice A non singolare associato a tale norma e relativo alla 
% risoluzione di sistemi lineari  dato dal seguente numero 
% mu(A)=||A||||A'||
% Si dice che una matrice  ben condizionata se il suo numero di 
% condizionamento non  grande. 
% Dato un sistema lineare del tipo Ax=b, il numero di condizionamento 
% fornisce informazioni sull'entit della variazione della soluzione esatta
% al variare dei termini noti. Il numero di condizionamento ci dice quindi 
% se il problema  ben condizionato.
% Se in numero di condizionamento mu(A)  grande devo aspettarmi che 
% piccole variazioni dei valori dei termini noti producano grandi 
% variazioni della soluzione esatta.
% Il numero di condizionamento della matrice identit vale 1, perch con 
% qualsiasi norma naturale ||I||=1 e I=I-1
% Propriet che del numero di condizionamento di una matrice
% 1)	mu(kA) = mu(A) per ogni matrice A e ogni scalare k
% 2)	mu(A)>=1 se la norma  naturale
% 3)	mu2(A)=Smax/Smin ; dove Smax=sqrt(max[1<=i<=n]li)  con li autovalori di A e n ordine di A
% 4)	mu2(A)=1 se A=kQ dove k  uno scalare e Q  la matrice unitaria
% Non esiste alcuna relazione tra il numero di condizionamento di una 
% matrice ed il suo determinante. Il determinante di una matrice non da 
% buona indicazione del malcondizionamento di una matrice.

% === EOF =================================================================