clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_07_02.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-18
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Risoluzione Ax=b con Gauss Naive Pivotting');

n = input('Inserisci la dimensione del sistema: ');

if isnumeric(n) & (n > 0)
    % calcolo una nuova matrice finch il det(A) = 0 e finch l'utente
    % vuole continuare 
    reply = 's'; % risposte utente
    while strcmpi(reply, 's')
        reply = 'n';
        disp('genero una matrice casuale');
        A = rand(n);
        % Annullo il determinante di un minore estratto
        % imponendo a 0 la riga 2 fino a l'indice n-1.
        for i = 1:n-1
            A(2,i) = 0;
        end
        disp(A);
        if (cond(A) >= 1/eps)
            % chiede all'utente se generare una nuova matrice
            disp('la matrice  mal condizionata');
            reply = input('genero una nuova matrice? S/N [N]: ','s');
        else
            disp('genero la soluzione esatta del problema');
            xx = rand(n,1)

            disp('calcolo il vettore dei termini noti');
            b = A * xx

            disp('triangolarizzo il sistema');
            A = gaussNaivePivot([A,b])
            
            disp('calcolo la soluzione approssimata');
            x = triangSup([A,b])

            % Stampa l'errore di approssimazione con la norma euclidea
            disp(sprintf('L''errore commesso  (norma euclidea): %d', norm(xx-x)));
        end
   end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% === EOF =================================================================