clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_08_01.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-18
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Risoluzione Ax=b con Gauss Naive Pivotting Scalato');

n = input('Inserisci la dimensione del sistema: ');

if isnumeric(n) & (n > 0)
    % calcolo una nuova matrice finch il det(A) = 0 e finch l'utente
    % vuole continuare 
    reply = 's'; % risposte utente
    while strcmpi(reply, 's')
        reply = 'n';
        disp('genero una matrice casuale');
        A = rand(n)
        if (cond(A) >= 1/eps)
            % chiede all'utente se generare una nuova matrice
            disp('la matrice  mal condizionata');
            reply = input('genero una nuova matrice? S/N [N]: ','s');
        else
            disp('genero la soluzione esatta del problema');
            xx = rand(n,1)

            disp('calcolo il vettore dei termini noti');
            b = A * xx

            disp('triangolarizzo il sistema');
            A = gaussNaivePivotScalato([A,b])
            
            disp('calcolo la soluzione approssimata');
            x = triangSup([A,b])

            % Stampa l'errore di approssimazione con la norma euclidea
            disp(sprintf('L''errore commesso  (norma euclidea): %d', norm(xx-x)));
        end
   end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% -------------------------------------------------------------------------
% NOTE DI TEORIA
% -------------------------------------------------------------------------
%
% 1. strategia del pivot
% Dato un sistema lineare Ax=b, consiste nello scambiare le righe 
% (pivotting parziale) e le colonne (pivotting totale) in modo tale che il 
% coefficiente (di x1 nel caso del parziale) col valore assoluto pi grande
% (pivot) risulti nella prima riga e nella prima colonna della sottomatrice
% in esame.
% Nel pivoting totale si scambiano solo righe e colonne, mentre in quello
% parziale (o scalato) si scambiano solo le righe.
%
% 2. Vantaggi della strategia del pivot
% Rende sempre applicabile l'algoritmo di Gauss (se det(A)!=0) e ne 
% migliora l'acuratezza.
%
% 3. Scaling di una matrice A nxn
% E una tecnica che consiste nel moltiplicare per una costante le righe o 
% le colonne della matrice.
% Consiste nella sostituzione del sistema con uno equivalente. 
% Siano Dr e Dc delle matrici diagonali non singolari
% scaling per righe: Ax=b ? DrAx=Drb,
% scaling per colonne: Ax=b ? ADc(inv(Dc)x)=b ? (ADc)y=b con y nuova 
% incognita

% === EOF =================================================================