clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_10.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-18
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Risoluzione Ax=b con Cholesky');

n = input('Inserisci la dimensione del sistema: ');

if isnumeric(n) & (n > 0)
    % calcolo una nuova matrice finch il det(A) = 0 e finch l'utente
    % vuole continuare 
    reply = 's'; % risposte utente
    while strcmpi(reply, 's')
        reply = 'n';
        disp('genero una matrice casuale');
        C = rand(n)
        % Genero la matrice casuale simmetrica definita positiva
        A = C' * C;
        if (cond(A) >= 1/eps)
            % chiede all'utente se generare una nuova matrice
            disp('la matrice  mal condizionata');
            reply = input('genero una nuova matrice? S/N [N]: ','s');
        else
            disp('genero la soluzione esatta del problema');
            xx = rand(n,1)

            disp('calcolo il vettore dei termini noti');
            b = A * xx

            disp('triangolarizzo il sistema');
            [R,ni] = cholesky(A)  % A = RR'
            
            disp('calcolo la soluzione approssimata');
            [y,nii] = triangInf([R,b])
            [x,nis] = triangSup([R',y])
                        
            ni = ni + nii + nis; % calcolo il numero di operazioni totali
            
            disp(sprintf('Numero di operazioni totali: %d', ni));
            
            % Stampa l'errore di approssimazione con la norma euclidea
            disp(sprintf('L''errore commesso  (norma euclidea): %d', norm(xx-x)));
        end
   end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% -------------------------------------------------------------------------
% NOTE DI TEORIA
% -------------------------------------------------------------------------
%
% 1. L'algoritmo di Cholesky  valido se la matrice  simmetrica e definita
% positiva. La complessit computazionale  n^3 / 6.
%
% 2. Nel caso di A, matrice simmetrica (A=A') la fattorizzazione si 
% riscrive A=LDMT
% Nel caso particolare in cui A sia simmetrica e A=LDMT si ha L=M cio 
% A=MDMT 
% Una matrice A  definita positiva se x'Ax >= 0 qualunque x!=0 
% appartenente adRn. 
% Se A  definita positiva tutti gli autovalori e i minori principali sono
% maggiori o uguali a zero.
%
% La soluzione x^ trovata con Cholesky si pu interpretare come soluzione 
% esatta del sistema perturbato (A+E)x^=b dove E  la matrice di 
% perturbazione le cui entrate hanno un ordine di grandezza molto piccolo 
% rispetto ad A, infatti vale ||E||2 <= cn eps||A||2 dove cn  una costante
% molto piccola dipendente da n (n = ordine della matrice A). 
% La soluzione risulta quindi accettabile.

% === EOF =================================================================