clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_11.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-18
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Tempo di risoluzione Ax=b con Gauss Naive Pivotting Scalato');

i= 1; % indice del vettore dei tempi

disp('attendere...');
for n = 10:10:200
    % calcolo una nuova matrice finch il det(A) = 0 e finch l'utente
    % vuole continuare 
    reply = 's'; % risposte utente
    while strcmpi(reply, 's')
        reply = 'n';
        A = rand(n);
        if (cond(A) >= 1/eps)
            % chiede all'utente se generare una nuova matrice
            disp('la matrice  mal condizionata');
            reply = input('genero una nuova matrice? S/N [N]: ','s');
        else
            % genero la soluzione esatta del problema
            xx = rand(n,1);

            % calcolo il vettore dei termini noti
            b = A * xx;
            
            time_start = cputime; % start timer

            % triangolarizzo il sistema
            A = gaussNaivePivotScalato([A,b]);
            
            % calcolo la soluzione approssimata
            x = triangSup([A,b]);
            
            time_stop = cputime; % stop timer
            
            % Memorizzo il tempo impiegato per risolevere il sistema
            tempi(i)= time_stop - time_start;
            dimensioni(i) = n;
            i = i + 1;
        end
    end
end

plot(dimensioni,tempi);
legend('dimensione / tempo [sec]', 'Location', 'NW');

% === EOF =================================================================