clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_12.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-19
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Risoluzione Ax=b con A matrice a banda');

n = input('Inserisci la dimensione del sistema: ');
p = input('Inserisci il valore p della banda inferiore: ');
q = input('Inserisci il valore q della banda superiore: ');

if isnumeric(n) & (n > 0) & isnumeric(p) & (p >= 0) & isnumeric(q) & (q >= 0)
    % calcolo una nuova matrice finch il det(A) = 0 e finch l'utente
    % vuole continuare 
    reply = 's'; % risposte utente
    while strcmpi(reply, 's')
        reply = 'n';
        disp('genero una matrice casuale');
        A = rand(n);
        A = triu(A,-p);
        A = tril(A,q)
        
        if (cond(A) >= 1/eps)
            % chiede all'utente se generare una nuova matrice
            disp('la matrice  mal condizionata');
            reply = input('genero una nuova matrice? S/N [N]: ','s');
        else
            disp('genero la soluzione esatta del problema');
            xx = rand(n,1)

            disp('calcolo il vettore dei termini noti');
            b = A * xx
            
            time_start = cputime; % start timer
            
            disp('triangolarizzo il sistema');
            [L,U] = gaussBanda(A,p,q)
            
            disp('calcolo la soluzione approssimata');
            y = triangInf([L,b])
            x = triangSup([U,y])
            
            time_stop = cputime; % start timer
            
            % Stampa il tempo impiegato
            disp(sprintf('Tempo impiegato: %d secondi', time_stop - time_start));
            
            % Stampa l'errore di approssimazione con la norma euclidea
            disp(sprintf('L''errore commesso  (norma euclidea): %d', norm(xx-x)));
        end
   end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% -------------------------------------------------------------------------
% NOTE DI TEORIA
% -------------------------------------------------------------------------
%
% 1. Matrici sparse
% sono le matrici che hanno molti elementi uguali a zero.
% In generale parliamo di matrice sparsa quando gli elementi diversi da
% zero sono dellordine O(n), dove n  lordine della matrice
%
% 2. Matrici a banda
% sono matrici in cui compaiono zeri al di sopra e/o al di sotto delle 
% diagonali secondarie. 
% Una matrice A si dice:
%    - a banda superiore q se aij=0 per j>i+q
%    - a banda inferiore p se aij=0 per i>j+q
%
% Se A  una matrice nxn a banda superiore q ed inferiore p ed ammette la
% fattorizzazione A=LU, allora la matrice U avr banda superiore q e la
% matrice L avr banda inferiore p.
%
% 3. ERRORE COMMESSO
% Utilizzando l'analisi all'indietro dell'errore: A-E = LU.
% Supponendo di aver applicato Gauss in un calcolatore con precisione 
% aritmetica eps, allora ||E||inf <= n^2 gn eps||A||inf
% gn varia a seconda dei casi che si usi: pivotting parziale, 
% pivotting totale, A simmetrica definita positiva.

% === EOF =================================================================