clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_14.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-19
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Polinomio interpolante con Neville');

a = input('Inserisci l''estremo inferiore dell''intervallo: ');
b = input('Inserisci l''estremo superiore dell''intervallo: ');
n = input('Inserisci il numero di nodi: ');
m = input('Inserisci il numero di punti per il grafico: ');

if isnumeric(n) & (n >= 2) & isnumeric(m) & (m >= 2) & isnumeric(a) & isnumeric(b) & (b > a)        
        
    for i = 1:3
       % eseguo test con funzioni diverse
        switch i
            case 1
                disp('---------- TEST 1: y = 2sen(x)+2 ----------');
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun5(x);
                fxs = fun5(xs);
           case 2
                disp('---------- TEST 2: y = 1/(1+x^2)  (runge) ----------');
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun4(x);
                fxs = fun4(xs);
           case 3
                disp('---------- TEST 3: y = 1/(1+x^2)  (runge + chebichev) ----------');
                x = chebichev(a,b,n-1)'; % calcolo gli zeri di chebichev
                xs = linspace(a,b,m)';
                y = fun4(x);
                fxs = fun4(xs);
        end
        
        pxs = neville(xs,x,y);
        
        % faccio i grafici sovrapposti
        plot(x,y,'o',xs,fxs,xs,pxs,'*-');
        legend('y','fxs','pxs');
        
        reply = input('Premi [INVIO] per continuare');
    end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% -------------------------------------------------------------------------
% NOTE DI TEORIA
% -------------------------------------------------------------------------
%
% 1. L'algorimto di Neville permette di calcolare in un generico punto xs
% il valore del polinomio interpolante.
% Il procedimento  simile ad un tabellone di un girone sportivo ad
% eliminazione diretta. Prima si calcolano i polinomi nei vari punti e poi
% si calcolano dei polinomi tra i polinomi trovati e cosi via fino ad
% ottenere un unico polinomio.

% === EOF =================================================================