clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_15.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-19
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Polinomio interpolante con polyfit - polyval');

n = input('Inserisci il numero di nodi: ');
m = input('Inserisci il numero di punti per il grafico: ');

if isnumeric(n) & (n >= 2) & isnumeric(m) & (m >= 2)       
    
    for i = 1:4
       % eseguo test con funzioni diverse
        switch i
            case 1
                disp('---------- TEST 2: y = exp(-x)-sin(2 pi x) ----------');
                a = 0;
                b = 4;
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun6(x);
                fxs = fun6(xs);
           case 2
                disp('---------- TEST 3: y = (-3x+1.4)*sin(18x) ----------');
                a = 0.96609;
                b = 1.48907;
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun7(x);
                fxs = fun7(xs);
           case 3
                disp('---------- TEST 4: y = 1/(1+x^2)  (runge) ----------');
                a = -6;
                b = 6;
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun4(x);
                fxs = fun4(xs);
           case 4
                disp('---------- TEST 5: y = 1/(1+x^2)  (runge + chebichev) ----------');
                a = -6;
                b = 6;
                x = chebichev(a,b,n-1)';
                xs = linspace(a,b,m)';
                y = fun4(x);
                fxs = fun4(xs);
        end
        
        % trovo i coefficienti del polinomio interpolante di grado n-1
        p = polyfit(xs,fxs,n-1);
        
        % trovo la tabulazione del polinomio interpolante calcolato in xs 
        pxs = polyval(p,xs);
        
        % faccio i grafici sovrapposti
        plot(x,y,'o',xs,fxs,xs,pxs,'*-');
        legend('y','fxs','pxs');
        
        reply = input('Premi [INVIO] per continuare');
    end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% -------------------------------------------------------------------------
% NOTE DI TEORIA
% -------------------------------------------------------------------------
%
% 1. TEOREMA di Weierstrass 
% Teorema sullapprossimazione di una funzione mediante un polinomio.
% Sia f(x) una funzione continua su un intervallo limitato e chiuso [a,b]. 
% Allora per ogni epsilon>0 esiste un intero n=n(epsilon) e un polinomio 
% Pn(x) di grado al pi n tale che:  ||f(x)-Pn(x)||inf < epsilon 
% con ||.||inf la norma del massimo per funzioni.
% Questo teorema dimostra che l'insieme delle funzioni continue C[a,b]  
% separabile. Infatti l'insieme dei polinomi 1,x,x2,x3,...  chiuso (o 
% completo) in C[a,b].
%
% 2. Matrice di interpolazione.
% Definiamo matrice di interpolazione sullintervallo [a,b] della retta 
% reale una matrice triangolare del tipo con elementi xi^j appartenenti 
% all'intervallo[a,b] e gli elementi in ciascuna riga distinti. 
% Gli elementi xi^j di ciascuna riga associati ai valori yij permettono la 
% costruzione dei polinomi interpolanti.
% 
% 3. TEOREMA di Faber sui polinomi interpolanti.
% Per ogni matrice di interpolazione di un intervallo limitato [a,b] della 
% retta reale esiste una funzione continua f(x) tale che Pn(f)(x) non 
% converge uniformemente a f(x) per n che tende ad infinito, cio 
% lim[n->inf](||f(x) - Pn(f)(x)||inf) non tende a zero.
%
% 4. TEOREMA
% Se f(x)  una funzione continua in un intervallo [a,b] si pu scegliere 
% una matrice di interpolazione in modo che la corrispondente successione 
% dei polinomi converga uniformemente a f(x) su [a,b].
% 
% 5. Potendo scegliere la matrice di interpolazione, per avere la 
% convergenza uniforme, sceglio gli elementi in modo che siano alla i-esima
% riga gli zeri del polinomio di Chebichev su [a,b]:
% T0=1, T1=x, Tn+1(x)=2xTn(x)-Tn-1(x)
% si considerano nell'intervallo [-1,1], gli zeri di Tn+1(x) sono dati da: 
% zn+1,i = cos((2m-1)pi / 2(n+1)), per i=1,...,n+1

% === EOF =================================================================