clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_16.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-19
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Spline iterpolante');

n = input('Inserisci il numero di nodi: ');
m = input('Inserisci il numero di punti per il grafico: ');

if isnumeric(n) & (n >= 2) & isnumeric(m) & (m >= 2)       
    
    for i = 1:5
       % eseguo test con funzioni diverse
        switch i
            case 1
                disp('---------- TEST 1: y = 2sen(x)+2 ----------');
                a = -20;
                b = 20;
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun5(x);
                fxs = fun5(xs);
            case 2
                disp('---------- TEST 2: y = exp(-x)-sin(2 pi x) ----------');
                a = 0;
                b = 4;
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun6(x);
                fxs = fun6(xs);
           case 3
                disp('---------- TEST 3: y = (-3x+1.4)*sin(18x) ----------');
                a = 0.96609;
                b = 1.48907;
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun7(x);
                fxs = fun7(xs);
           case 4
                disp('---------- TEST 4: y = 1/(1+x^2)  (runge) ----------');
                a = -6;
                b = 6;
                x = linspace(a,b,n)';
                xs = linspace(a,b,m)';
                y = fun4(x);
                fxs = fun4(xs);
           case 5
                disp('---------- TEST 5: y = 1/(1+x^2)  (runge + chebichev) ----------');
                a = -6;
                b = 6;
                x = chebichev(a,b,n-1)';
                xs = linspace(a,b,m)';
                y = fun4(x);
                fxs = fun4(xs);
        end
        
        % interpolo tramite spline lineare
        pxs = spline1(xs,x,y);
        
        % faccio i grafici sovrapposti
        plot(x,y,'o',xs,fxs,xs,pxs,'*-');
        legend('y','fxs','pxs');
        
        reply = input('Premi [INVIO] per continuare');
    end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% -------------------------------------------------------------------------
% NOTE DI TEORIA
% -------------------------------------------------------------------------
%
% 1. Approssimazione mediante funzioni spline.
% Lintervallo [a,b] di definizione della funzione che si vuole
% approssimare  suddiviso in sottointervalli [xi,xi+1] ed in ciascuno di 
% questi si approssima la funzione con un polinomio di grado basso (1, 2 o 
% 3). La funzione risultante composta dai polinomi di cui sopra,  chiamata
% funzione spline di grado 1, 2 o 3.
%
% 2. Definizione di funzione spline.
% Sia D{a=x0<x1<...<xn=b} una suddivisione dellintervallo [a,b]. 
% Una funzione spline di grado p con nodi nei punti xi i=0,1,2,,n  una 
% funzione su [a,b] indicata con sp(x) tale che 
%     1. su ogni intervallo [xi,xi+1], i=0,1,2,...,n-1,  un polinomio di 
%        grado p.
%     2. la sua funzione sp(x) e le sue prime p-1 derivate sono contnue su 
%        [a,b].
% 3. Funzioni spline interpolanti.
% Data la tabulazione di una funzione f(x), (xi,yi), i=0,1,...,n, si chiama
% spline interpolante la spline sp(x) tale che: sp(xi)=yi
%
% 4. Splines continue e lineari a tratti.
% Sono le splines s1(x) di grado 1. Sono dei polinomi di grado 1 di classe 
% C(0), cio delle rette. I gradi di libert sono n+1. 
% La soluzione esiste ed  unica.
%
% 5. Vantaggi delle spline.
%  - convergenza al tendere a zero dell'ampiezza del massimo
%  sottointervallo della suddivisione di [a,b]
%  - influenza di un eventuale errore nella valutazione di un valore yi in
%  xi ai soli sottointervalli che contengono xi.

% === EOF =================================================================