clc; % clear command window
clear; % frees system memory
echo on; % turns on the echoing of commands in all script files
% =========================================================================
% File name   : ES_18_02.m
% File Type   : m-file (script file for matlab or octave)
% Begin       : 2005-01-18
% Last Update : 2005-01-19
% Author      : Nicola Asuni [38433]
% Description : Esercitazione di Analisi Numerica
%               A.A. 2004-2005
%               Prof. M. Gaviano
%               UNIVERSIT DEGLI STUDI DI CAGLIARI
%               Facolt di Scienze Matematiche Fisiche Naturali
%               Dipartimento di Matematica ed Informatica
%               Corso di Laurea in Informatica
% =========================================================================
echo off;

disp('Polinomio interpolante POLYFIT + errore casuale');

m = input('Inserisci il numero di nodi m: ');
n = input('Inserisci il grado del polinomio n < m: ');
p = input('Inserisci il numero di punti per il grafico: ');

if isnumeric(m) & (m > 1) & isnumeric(n) & (n > 0) & (n < m) & isnumeric(p) & (p > 0)      
    
    for i = 1:5
       % eseguo test con funzioni diverse
        switch i
            case 1
                disp('---------- TEST 1: y = 2sen(x)+2 ----------');
                a = -20;
                b = 20;
                x = linspace(a,b,m)';
                xs = linspace(a,b,p)';
                y = fun5(x);
                fxs = fun5(xs);
            case 2
                disp('---------- TEST 2: y = exp(-x)-sin(2 pi x) ----------');
                a = 0;
                b = 4;
                x = linspace(a,b,m)';
                xs = linspace(a,b,p)';
                y = fun6(x);
                fxs = fun6(xs);
           case 3
                disp('---------- TEST 3: y = (-3x+1.4)*sin(18x) ----------');
                a = 0.96609;
                b = 1.48907;
                x = linspace(a,b,m)';
                xs = linspace(a,b,p)';
                y = fun7(x);
                fxs = fun7(xs);
           case 4
                disp('---------- TEST 4: y = 1/(1+x^2)  (runge) ----------');
                a = -6;
                b = 6;
                x = linspace(a,b,m)';
                xs = linspace(a,b,p)';
                y = fun4(x);
                fxs = fun4(xs);
           case 5
                disp('---------- TEST 5: y = 1/(1+x^2)  (runge + chebichev) ----------');
                a = -6;
                b = 6;
                x = chebichev(a,b,n)';
                xs = linspace(a,b,p)';
                y = fun4(x);
                fxs = fun4(xs);
        end
        
        % introduco un errore casuale del 10%
        error_perc = 10; % percentuale di errore da introdurre 
        y = y-(y/error_perc)+((y/(error_perc/2)).*rand(length(x),1));
        fxs = fxs-(fxs/error_perc)+((fxs/(error_perc/2)).*rand(p,1));
        
        % trovo i coefficienti del polinomio interpolante di grado n-1
        aa = polyfit(x,y,n-1);
        
        % trovo la tabulazione del polinomio interpolante calcolato in xs 
        pxs = polyval(aa,xs);
        
        % faccio i grafici sovrapposti
        plot(x,y,'o',xs,fxs,xs,pxs,'*-');
        legend('y','fxs','mxs');
        
        reply = input('Premi [INVIO] per continuare');
    end
else
   disp('ERRORE NEI DATI DI INPUT!'); 
end

% === EOF =================================================================