function [A,ni] = cholesky(A)
    % =====================================================================
    % File name   : cholesky.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-18
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
   
    % Algoritmo di Cholesky per la fattorizzazione RR' di A.
    % A  una matrice simmetrica, non singolare, definita positiva.
    % Dopo l'applicazione dell'algoritmo A contiene la fattorizzazione di
    % se stessa.
    % ni contiene il numero di moltiplicazioni e divisioni.

    [n, col] = size(A); % numero di righe e colonne
    ni = 0; % contatore numero di operazioni
    
    for k = 1:n  % indice di colonna
        %genero gli elementi della diagonale principale di A
        if k==1
            A(k,k) = sqrt(A(k,k));
        else
            A(k,k) = sqrt(A(k,k) - A(k,1:k-1) * A(k,1:k-1)');
        end
        for i = k+1:n  % indice di riga
            % genero gli elementi del triangolo inferiore di A
            if k==1
                A(i,k) = A(i,k) / A(k,k);
            else
                A(i,k) = (A(i,k) - A(i,1:k-1) * A(k,1:k-1)') / A(k,k);
            end
        end
    end
        
% === EOF =================================================================
