function [L,U] = gaussBanda(A,p,q)
    % =====================================================================
    % File name   : gaussBanda.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-18
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
   
    % Algoritmo di Gauss per la fattorizzazione LU di una matrice a banda
    % inferiore p e superiore q.
    % ni contiene il numero di moltiplicazioni e divisioni.

    [n, col] = size(A); % numero di righe e colonne
    for k = 1:n-1
        for i = k+1:min(k+p,n)
            A(i,k) = A(i,k) / A(k,k);
        end
        for i = k+1:min(k+p,n)
            for j = k+1:min(k+q,n)
                A(i,j) = A(i,j) - A(i,k) * A(k,j);
            end
        end
    end
    L = eye(n) + tril(A,-1);
    U = triu(A);
        
% === EOF =================================================================

