function [L,U,ni] = gaussDoolitle(A)
    % =====================================================================
    % File name   : gaussDoolitle.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-18
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
   
    % Algoritmo dolittle di fattorizzazione LU di A.
    % Alla fine dell'algoritmo A contiene la fattorizzazione di se stessa.
    % ni contiene il numero di moltiplicazioni e divisioni

    [n, col] = size(A); % numero di righe e colonne
    ni = 0; % contatore numero di operazioni
    
    L = eye(n); % inizializzo L alla matrice identit
    for k = 1:n
        for i = k:n        
            if k==1      
                U(k,i) = A(k,i);
            else
                U(k,i) = A(k,i) - L(k,1:k-1) * U(1:k-1,i);
            end
            ni = ni + 2 * (k - 1);  %k-1 sottrazioni e k-1 moltiplicazioni.
        end  
        for i = k+1:n
            if k==1
                L(i,k) = A(i,k) / U(k,k);
            else      
                L(i,k) = (A(i,k) - L(i,1:k-1) * U(1:k-1,k)) / U(k,k);
            end
            ni = ni + 1 + 2 * (k - 1); % 1 divisione, k-1 moltiplicazioni e k-1 sottrazioni.
        end
    end
    
% === EOF =================================================================

