function A = gaussNaive(A)
    % =====================================================================
    % File name   : gaussNaive.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-18
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
   
    % L'algoritmo di Gauss Naive consente di risolvere un sistema lineare
    % del tipo Ax=b trasformandolo in un sistema triangolare superiore.
    % IMPORTANTE: si pu applicare solo se tutti gli A(i,i) sono diversi da
    % zero.
    % La complessit di questo algoritmo  O(n^3)
    
    [n, col] = size(A); % numero di righe e colonne
    for k = 1:n-1
        for i = k+1:n
            m = A(i,k) / A(k,k); % moltiplicatori
            for j = k+1:n+1
                A(i,j) = A(i,j) - m * A(k,j);
            end
        end
    end

% === EOF =================================================================

