function A = gaussNaivePivot(A)
    % =====================================================================
    % File name   : gaussNaivePivot.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-18
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
   
    % L'algoritmo di Gauss Naive con Pivotting Parziale (scambio di righe)
    % consente di risolvere un sistema lineare del tipo Ax=b trasformandolo
    % in un sistema triangolare superiore.
    % Lo scambio delle righe (pivotting) rende sempre applicabile
    % l'argoritmo Gauss Naive se det(A)!=0.
    
    [n, col] = size(A); % numero di righe e colonne
    
    for k = 1:(n-1)
        % M  il valore max dei rapporti, p indice relativo a k in cui si trova M
        [M,p] = max(abs(A(k:n,k)));
        % Ristabilisce l'indice p rispetto alla matrice completa 
        p = p + k - 1;
        if (k ~= p)
            % scambio la riga p con la riga k
            B = A(k,k:n+1); 
            A(k,k:n+1) = A(p,k:n+1);  
            A(p,k:n+1) = B;
        end
        for i = (k+1):n
            m = A(i,k) / A(k,k); % moltiplicatore
            for j = (k+1):(n+1)
                A(i,j) = A(i,j) - m * A(k,j);
            end
        end
    end
    
% === EOF =================================================================

