function A = gaussNaivePivotScalato(A)
    % =====================================================================
    % File name   : gaussNaivePivotScalato.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-18
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
   
    % L'algoritmo di Gauss Naive con Pivotting Parziale (scambio di righe)
    % consente di risolvere un sistema lineare del tipo Ax=b trasformandolo
    % in un sistema triangolare superiore.
    % Lo scambio delle righe (pivotting) rende sempre applicabile
    % l'argoritmo Gauss Naive se det(A)!=0.
    
    [n, col] = size(A); % numero di righe e colonne
    
    % scalo il sistema
    for i = 1:n
        d(i) = max(abs(A(i,1:n)));
        A(i,:) = A(i,:) / d(i); 
    end
    
    A = gaussNaivePivot(A); % applico Gauss - Naive con Pivotting
    
% === EOF =================================================================

