function x = gaussSeidel(A,b,acc,itmax)
    % =====================================================================
    % File name   : gaussSeidel.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-19
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
   
    % Algoritmo di Gauss-Seidel
    % acc = accuratezza massima richiesta
    % imax = numero di iterazioni massime
    
    [n, col] = size(A); % numero di righe e colonne
    x0 = rand(n,1);
    x1 = -x0;
    k = 0; % iterazioni
    
    while (k <= itmax) & (norm(x1 - x0) > acc)
        k = k + 1;
        x0 = x1;
        for i = 1:n;
            if i == 1
                x1(i) = (b(i) - A(i,i+1:n) * x0(i+1:n)) / A(i,i);
            elseif i == n
                x1(i) = (b(i) - A(i,1:i-1) * x1(1:i-1)) / A(i,i);
            else    
                x1(i) = (b(i) - A(i,1:i-1) * x1(1:i-1) - A(i,i+1:n) * x0(i+1:n)) / A(i,i);
            end  
        end
    end
    if (k < itmax)
        x = x1;
    else
        x = NaN;
    end
        
% === EOF =================================================================

