function mxs = minQuadPoly(xs,x,y,n)
    % =====================================================================
    % File name   : minQuadPoly.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-19
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
    
    % Polinomio interpolante ottenuto con l'approssimazione nel senso dei
    % minimi quadrati
    
    m = length(x);
    
    % trovo la matrice M di interpolazione
    for i = 1:n+1
        for j = 1:n+1
            s = 0;
            for k = 1:m
                s = s + x(k).^(i+j-2);
            end
            M(i,j) = s;                               
        end
    end

    % trovo il vettore r dei termini noti di M*aa
    for i = 1:n+1
        c = 0;
        for k = 1:m
            c = c+(x(k)^(i-1)*y(k));                  
        end
        r(i) = c;                                     
    end

    % coefficienti del polinomio
    aa = inv(M) * r';

    % tabulazione del polinomio interpolante 
    mxs = polyval(aa(n+1:-1:1),xs);                   
    
% === EOF =================================================================

