function pxs = neville(xs,xi,yi)
    % =====================================================================
    % File name   : neville.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-19
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
    
    % Algoritmo di Neville
    % permette di calcolare in un generico punto x il valore del 
    % polinomio interpolante data la tabulazione xs,ys

    for k = 1:length(xs)
        t(1) = yi(1);
        for i = 2:length(xi)
            t(i) = yi(i);
            for j = i-1:-1:1
                t(j) = t(j+1) + (t(j+1) - t(j)) * (xs(k) - xi(i)) / (xi(i) - xi(j));
            end
        end
        pxs(k) = t(1);
    end
        
% === EOF =================================================================

