function [y,ni] = triangInf(L)
    % =====================================================================
    % File name   : triangInf.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-18
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
    % Questa funzione risolve un sistema triangolare inferiore.
    % l'ultima colonna della matrice contiene i termini noti.
    % ni tiene traccia del numero di moltiplicazioni e divisioni

    [n, m] = size(L); % get number of rows
    y(1,1) = L(1,n+1) / L(1,1);
    ni = 1;
    for i = 2:n
        y(i,1) = L(i,n+1);
        for j = 1:i-1
            y(i,1) = y(i,1) - L(i,j) * y(j);
            ni = ni + 2;
        end
        y(i,1) = y(i,1) / L(i,i);
        ni = ni + 1;
    end

% === EOF =================================================================

