function [x,ni] = triangSup(U)
    % =====================================================================
    % File name   : triangSup.m
    % File Type   : m-file (script file for matlab or octave)
    % Begin       : 2005-01-18
    % Last Update : 2005-01-18
    % Author      : Nicola Asuni [38433]
    % Description : Esercitazione di Analisi Numerica
    %               A.A. 2004-2005
    %               Prof. M. Gaviano
    %               UNIVERSIT DEGLI STUDI DI CAGLIARI
    %               Facolt di Scienze Matematiche Fisiche Naturali
    %               Dipartimento di Matematica ed Informatica
    %               Corso di Laurea in Informatica
    % =====================================================================
    % Questa funzione risolve un sistema triangolare superiore.
    % l'ultima colonna della matrice contiene i termini noti.
    % ni tiene traccia del numero di moltiplicazioni e divisioni
    
    [n, m] = size(U);
    x(n,1) = U(n,n+1) / U(n,n);
    ni = 1;
    for i = n-1:-1:1
        x(i,1) = U(i,n+1);
        for j = n:-1:i+1
            x(i,1) = x(i,1) - U(i,j) * x(j);
            ni = ni + 2;
        end
        x(i,1) = x(i,1) / U(i,i);
        ni = ni + 1;
    end
    
% === EOF =================================================================

